<?php
/* Autor...: William L. Taype Perez */
/* Esquema.: VTA_PrsProyectos.xml */
/* Generado: 2021-05-25 04:23:20 */

/* Mantenimiento de los registros de la tabla VTA_PrsProyectos */
abstract class BaseVTA_PrsProyectosDP extends VTA_PrsProyectosBV
{
    /* Constructor ( Establece los valores desde un objeto VTA_PrsProyectosBN ) */
    public function __construct( VTA_PrsProyectosBN $o_VTA_PrsProyectosBN = null )
    {
        parent::__construct();
        if ( !is_null( $o_VTA_PrsProyectosBN ) )
        {
            $this->setByBN( $o_VTA_PrsProyectosBN );
        }
    }

    public $b_Debug = false;

    public function getDebug()
    {
        if( SF_DEBUG )
        {
            $this->b_Debug = true;
        }
        return $this->b_Debug;
    }

    public function setDebug( $v )
    {
        $this->b_Debug = $v;
    }

    /* Establece los valores desde un objeto VTA_PrsProyectosBN */
    public function setByBN( VTA_PrsProyectosBN $o_VTA_PrsProyectosBN )
    {
        if ( !is_null( $o_VTA_PrsProyectosBN->getIdProyecto() ) )
        {
            $this->setIdProyecto( $o_VTA_PrsProyectosBN->getIdProyecto() );
        }
        if ( !is_null( $o_VTA_PrsProyectosBN->getIdPersona() ) )
        {
            $this->setIdPersona( $o_VTA_PrsProyectosBN->getIdPersona() );
        }
        if ( !is_null( $o_VTA_PrsProyectosBN->getClienteNombre() ) )
        {
            $this->setClienteNombre( $o_VTA_PrsProyectosBN->getClienteNombre() );
        }
        if ( !is_null( $o_VTA_PrsProyectosBN->getClienteTipoDocu() ) )
        {
            $this->setClienteTipoDocu( $o_VTA_PrsProyectosBN->getClienteTipoDocu() );
        }
        if ( !is_null( $o_VTA_PrsProyectosBN->getClienteNroDocu() ) )
        {
            $this->setClienteNroDocu( $o_VTA_PrsProyectosBN->getClienteNroDocu() );
        }
        if ( !is_null( $o_VTA_PrsProyectosBN->getNombreCompleto() ) )
        {
            $this->setNombreCompleto( $o_VTA_PrsProyectosBN->getNombreCompleto() );
        }
        if ( !is_null( $o_VTA_PrsProyectosBN->getNombreProyecto() ) )
        {
            $this->setNombreProyecto( $o_VTA_PrsProyectosBN->getNombreProyecto() );
        }
        if ( !is_null( $o_VTA_PrsProyectosBN->getContacto() ) )
        {
            $this->setContacto( $o_VTA_PrsProyectosBN->getContacto() );
        }
        if ( !is_null( $o_VTA_PrsProyectosBN->getTipoDocumento() ) )
        {
            $this->setTipoDocumento( $o_VTA_PrsProyectosBN->getTipoDocumento() );
        }
        if ( !is_null( $o_VTA_PrsProyectosBN->getNroDocumento() ) )
        {
            $this->setNroDocumento( $o_VTA_PrsProyectosBN->getNroDocumento() );
        }
        if ( !is_null( $o_VTA_PrsProyectosBN->getCargo() ) )
        {
            $this->setCargo( $o_VTA_PrsProyectosBN->getCargo() );
        }
        if ( !is_null( $o_VTA_PrsProyectosBN->getTelefono() ) )
        {
            $this->setTelefono( $o_VTA_PrsProyectosBN->getTelefono() );
        }
        if ( !is_null( $o_VTA_PrsProyectosBN->getCorreo() ) )
        {
            $this->setCorreo( $o_VTA_PrsProyectosBN->getCorreo() );
        }
        if ( !is_null( $o_VTA_PrsProyectosBN->getEstado() ) )
        {
            $this->setEstado( $o_VTA_PrsProyectosBN->getEstado() );
        }
        if ( !is_null( $o_VTA_PrsProyectosBN->getEstadoDevolucion() ) )
        {
            $this->setEstadoDevolucion( $o_VTA_PrsProyectosBN->getEstadoDevolucion() );
        }
        if ( !is_null( $o_VTA_PrsProyectosBN->getFechaInicioDespacho() ) )
        {
            $this->setFechaInicioDespacho( $o_VTA_PrsProyectosBN->getFechaInicioDespacho() );
        }
        if ( !is_null( $o_VTA_PrsProyectosBN->getFechaFinDespacho() ) )
        {
            $this->setFechaFinDespacho( $o_VTA_PrsProyectosBN->getFechaFinDespacho() );
        }
        if ( !is_null( $o_VTA_PrsProyectosBN->getDepartamento() ) )
        {
            $this->setDepartamento( $o_VTA_PrsProyectosBN->getDepartamento() );
        }
        if ( !is_null( $o_VTA_PrsProyectosBN->getProvincia() ) )
        {
            $this->setProvincia( $o_VTA_PrsProyectosBN->getProvincia() );
        }
        if ( !is_null( $o_VTA_PrsProyectosBN->getDistrito() ) )
        {
            $this->setDistrito( $o_VTA_PrsProyectosBN->getDistrito() );
        }
        if ( !is_null( $o_VTA_PrsProyectosBN->getDireccion() ) )
        {
            $this->setDireccion( $o_VTA_PrsProyectosBN->getDireccion() );
        }
        if ( !is_null( $o_VTA_PrsProyectosBN->getFechaCreacion() ) )
        {
            $this->setFechaCreacion( $o_VTA_PrsProyectosBN->getFechaCreacion() );
        }
        if ( !is_null( $o_VTA_PrsProyectosBN->getUsuarioCreacion() ) )
        {
            $this->setUsuarioCreacion( $o_VTA_PrsProyectosBN->getUsuarioCreacion() );
        }
        if ( !is_null( $o_VTA_PrsProyectosBN->getUsuarioModificacion() ) )
        {
            $this->setUsuarioModificacion( $o_VTA_PrsProyectosBN->getUsuarioModificacion() );
        }
        if ( !is_null( $o_VTA_PrsProyectosBN->getFechaModificacion() ) )
        {
            $this->setFechaModificacion( $o_VTA_PrsProyectosBN->getFechaModificacion() );
        }
    }

    /* Graba un nuevo registro */
    public function save()
    {
        $this->validateRecord();
        $o_VTA_PrsProyectosFN = new VTA_PrsProyectosFN();
        $o_VTA_PrsProyectosBN = $o_VTA_PrsProyectosFN->selectByPk( $this->getIdProyecto() );
        if ( is_null( $o_VTA_PrsProyectosBN ) )
        {
            $s_SQLQuery1 = "INSERT INTO VTA_PrsProyectos ( ";
            $s_SQLQuery2 = "VALUES ( ";
            $s_Separator = "";
            if ( !is_null( $this->getIdProyecto() ) )
            {
                $s_SQLQuery1 .= $s_Separator."IdProyecto";
                $s_SQLQuery2 .= $s_Separator."".$this->getIdProyecto()."";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getIdPersona() ) )
            {
                $s_SQLQuery1 .= $s_Separator."IdPersona";
                $s_SQLQuery2 .= $s_Separator."".$this->getIdPersona()."";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getClienteNombre() ) )
            {
                $s_SQLQuery1 .= $s_Separator."ClienteNombre";
                $s_SQLQuery2 .= $s_Separator."'".$this->getClienteNombre()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getClienteTipoDocu() ) )
            {
                $s_SQLQuery1 .= $s_Separator."ClienteTipoDocu";
                $s_SQLQuery2 .= $s_Separator."'".$this->getClienteTipoDocu()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getClienteNroDocu() ) )
            {
                $s_SQLQuery1 .= $s_Separator."ClienteNroDocu";
                $s_SQLQuery2 .= $s_Separator."'".$this->getClienteNroDocu()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getNombreCompleto() ) )
            {
                $s_SQLQuery1 .= $s_Separator."NombreCompleto";
                $s_SQLQuery2 .= $s_Separator."'".$this->getNombreCompleto()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getNombreProyecto() ) )
            {
                $s_SQLQuery1 .= $s_Separator."NombreProyecto";
                $s_SQLQuery2 .= $s_Separator."'".$this->getNombreProyecto()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getContacto() ) )
            {
                $s_SQLQuery1 .= $s_Separator."Contacto";
                $s_SQLQuery2 .= $s_Separator."'".$this->getContacto()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getTipoDocumento() ) )
            {
                $s_SQLQuery1 .= $s_Separator."TipoDocumento";
                $s_SQLQuery2 .= $s_Separator."'".$this->getTipoDocumento()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getNroDocumento() ) )
            {
                $s_SQLQuery1 .= $s_Separator."NroDocumento";
                $s_SQLQuery2 .= $s_Separator."'".$this->getNroDocumento()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getCargo() ) )
            {
                $s_SQLQuery1 .= $s_Separator."Cargo";
                $s_SQLQuery2 .= $s_Separator."'".$this->getCargo()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getTelefono() ) )
            {
                $s_SQLQuery1 .= $s_Separator."Telefono";
                $s_SQLQuery2 .= $s_Separator."'".$this->getTelefono()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getCorreo() ) )
            {
                $s_SQLQuery1 .= $s_Separator."Correo";
                $s_SQLQuery2 .= $s_Separator."'".$this->getCorreo()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getEstado() ) )
            {
                $s_SQLQuery1 .= $s_Separator."Estado";
                $s_SQLQuery2 .= $s_Separator."'".$this->getEstado()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getEstadoDevolucion() ) )
            {
                $s_SQLQuery1 .= $s_Separator."EstadoDevolucion";
                $s_SQLQuery2 .= $s_Separator."'".$this->getEstadoDevolucion()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getFechaInicioDespacho() ) )
            {
                $s_SQLQuery1 .= $s_Separator."FechaInicioDespacho";
                $s_SQLQuery2 .= $s_Separator."'".$this->getFechaInicioDespacho()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getFechaFinDespacho() ) )
            {
                $s_SQLQuery1 .= $s_Separator."FechaFinDespacho";
                $s_SQLQuery2 .= $s_Separator."'".$this->getFechaFinDespacho()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getDepartamento() ) )
            {
                $s_SQLQuery1 .= $s_Separator."Departamento";
                $s_SQLQuery2 .= $s_Separator."'".$this->getDepartamento()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getProvincia() ) )
            {
                $s_SQLQuery1 .= $s_Separator."Provincia";
                $s_SQLQuery2 .= $s_Separator."'".$this->getProvincia()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getDistrito() ) )
            {
                $s_SQLQuery1 .= $s_Separator."Distrito";
                $s_SQLQuery2 .= $s_Separator."'".$this->getDistrito()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getDireccion() ) )
            {
                $s_SQLQuery1 .= $s_Separator."Direccion";
                $s_SQLQuery2 .= $s_Separator."'".$this->getDireccion()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getFechaCreacion() ) )
            {
                $s_SQLQuery1 .= $s_Separator."FechaCreacion";
                $s_SQLQuery2 .= $s_Separator."'".$this->getFechaCreacion()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getUsuarioCreacion() ) )
            {
                $s_SQLQuery1 .= $s_Separator."UsuarioCreacion";
                $s_SQLQuery2 .= $s_Separator."'".$this->getUsuarioCreacion()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getUsuarioModificacion() ) )
            {
                $s_SQLQuery1 .= $s_Separator."UsuarioModificacion";
                $s_SQLQuery2 .= $s_Separator."'".$this->getUsuarioModificacion()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getFechaModificacion() ) )
            {
                $s_SQLQuery1 .= $s_Separator."FechaModificacion";
                $s_SQLQuery2 .= $s_Separator."'".$this->getFechaModificacion()."'";
                $s_Separator = ", ";
            }
            $s_SQLQuery = $s_SQLQuery1." ) ".$s_SQLQuery2." );";
            if( $this->getDebug() ){ pr( $s_SQLQuery ); }
            $o_Resource = Conexion::getConexion();
            $o_Statement = $o_Resource->createStatement();
            $o_Statement->executeQuery( $s_SQLQuery );
        }
        else
        {
            throw new Exception( "El id ya esta registrado." );
        }
        return true;
    }

    /* Actualiza los datos del registro */
    public function update()
    {
        $this->validateRecord();
        if ( true )
        {
            $s_SQLQuery = "UPDATE VTA_PrsProyectos SET ";
            $s_Separator = "";
            if ( !is_null( $this->getIdPersona() ) )
            {
                $s_SQLQuery .= $s_Separator."IdPersona = ".$this->getIdPersona()."";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getClienteNombre() ) )
            {
                $s_SQLQuery .= $s_Separator."ClienteNombre = '".$this->getClienteNombre()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getClienteTipoDocu() ) )
            {
                $s_SQLQuery .= $s_Separator."ClienteTipoDocu = '".$this->getClienteTipoDocu()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getClienteNroDocu() ) )
            {
                $s_SQLQuery .= $s_Separator."ClienteNroDocu = '".$this->getClienteNroDocu()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getNombreCompleto() ) )
            {
                $s_SQLQuery .= $s_Separator."NombreCompleto = '".$this->getNombreCompleto()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getNombreProyecto() ) )
            {
                $s_SQLQuery .= $s_Separator."NombreProyecto = '".$this->getNombreProyecto()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getContacto() ) )
            {
                $s_SQLQuery .= $s_Separator."Contacto = '".$this->getContacto()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getTipoDocumento() ) )
            {
                $s_SQLQuery .= $s_Separator."TipoDocumento = '".$this->getTipoDocumento()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getNroDocumento() ) )
            {
                $s_SQLQuery .= $s_Separator."NroDocumento = '".$this->getNroDocumento()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getCargo() ) )
            {
                $s_SQLQuery .= $s_Separator."Cargo = '".$this->getCargo()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getTelefono() ) )
            {
                $s_SQLQuery .= $s_Separator."Telefono = '".$this->getTelefono()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getCorreo() ) )
            {
                $s_SQLQuery .= $s_Separator."Correo = '".$this->getCorreo()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getEstado() ) )
            {
                $s_SQLQuery .= $s_Separator."Estado = '".$this->getEstado()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getEstadoDevolucion() ) )
            {
                $s_SQLQuery .= $s_Separator."EstadoDevolucion = '".$this->getEstadoDevolucion()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getFechaInicioDespacho() ) )
            {
                $s_SQLQuery .= $s_Separator."FechaInicioDespacho = '".$this->getFechaInicioDespacho()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getFechaFinDespacho() ) )
            {
                $s_SQLQuery .= $s_Separator."FechaFinDespacho = '".$this->getFechaFinDespacho()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getDepartamento() ) )
            {
                $s_SQLQuery .= $s_Separator."Departamento = '".$this->getDepartamento()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getProvincia() ) )
            {
                $s_SQLQuery .= $s_Separator."Provincia = '".$this->getProvincia()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getDistrito() ) )
            {
                $s_SQLQuery .= $s_Separator."Distrito = '".$this->getDistrito()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getDireccion() ) )
            {
                $s_SQLQuery .= $s_Separator."Direccion = '".$this->getDireccion()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getFechaCreacion() ) )
            {
                $s_SQLQuery .= $s_Separator."FechaCreacion = '".$this->getFechaCreacion()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getUsuarioCreacion() ) )
            {
                $s_SQLQuery .= $s_Separator."UsuarioCreacion = '".$this->getUsuarioCreacion()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getUsuarioModificacion() ) )
            {
                $s_SQLQuery .= $s_Separator."UsuarioModificacion = '".$this->getUsuarioModificacion()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getFechaModificacion() ) )
            {
                $s_SQLQuery .= $s_Separator."FechaModificacion = '".$this->getFechaModificacion()."'";
                $s_Separator = ", ";
            }
            $s_SQLQuery .= " WHERE  IdProyecto = ".$this->getIdProyecto().";";
            if( $this->getDebug() ){ pr( $s_SQLQuery ); }

            $o_Resource = Conexion::getConexion();
            $o_Statement = $o_Resource->createStatement();
            $o_Statement->executeQuery( $s_SQLQuery );
        }
        else
        {
            throw new Exception( "El id no esta registrado." );
        }
        return true;
    }

    /* Elimina el registro */
    public function delete()
    {
        $s_SQLQuery = "DELETE FROM VTA_PrsProyectos WHERE  IdProyecto = ".$this->getIdProyecto().";";
        if( $this->getDebug() ){ pr( $s_SQLQuery ); }
        $o_Resource = Conexion::getConexion();
        $o_Statement = $o_Resource->createStatement();
        $o_Statement->executeQuery( $s_SQLQuery );
        return true;
    }

}
?>